import * as pulumi from "@pulumi/pulumi";
import * as outputs from "../types/output";
/**
 * Use this data source to retrieve all AWS log ready services.
 */
export declare function getIntegrationLogsServices(opts?: pulumi.InvokeOptions): Promise<GetIntegrationLogsServicesResult>;
/**
 * A collection of values returned by getIntegrationLogsServices.
 */
export interface GetIntegrationLogsServicesResult {
    /**
     * List of AWS log ready services.
     */
    readonly awsLogsServices: outputs.aws.GetIntegrationLogsServicesAwsLogsService[];
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
}
