"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Integration = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a Datadog - Amazon Web Services integration resource. This can be used to create and manage Datadog - Amazon Web Services integration.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Create a new Datadog - Amazon Web Services integration
 * const sandbox = new datadog.aws.Integration("sandbox", {
 *     accountId: "1234567890",
 *     accountSpecificNamespaceRules: {
 *         auto_scaling: false,
 *         opsworks: false,
 *     },
 *     excludedRegions: [
 *         "us-east-1",
 *         "us-west-2",
 *     ],
 *     filterTags: ["key:value"],
 *     hostTags: [
 *         "key:value",
 *         "key2:value2",
 *     ],
 *     roleName: "DatadogAWSIntegrationRole",
 * });
 * ```
 *
 * ## Import
 *
 * Amazon Web Services integrations can be imported using their account ID and role name separated with a colon (:), while the external_id should be passed by setting an environment variable called EXTERNAL_ID
 *
 * ```sh
 *  $ pulumi import datadog:aws/integration:Integration EXTERNAL_ID=${external_id} datadog_integration_aws.test ${account_id}:${role_name}
 * ```
 */
class Integration extends pulumi.CustomResource {
    /**
     * Get an existing Integration resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Integration(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Integration.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Integration.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["accessKeyId"] = state ? state.accessKeyId : undefined;
            resourceInputs["accountId"] = state ? state.accountId : undefined;
            resourceInputs["accountSpecificNamespaceRules"] = state ? state.accountSpecificNamespaceRules : undefined;
            resourceInputs["cspmResourceCollectionEnabled"] = state ? state.cspmResourceCollectionEnabled : undefined;
            resourceInputs["excludedRegions"] = state ? state.excludedRegions : undefined;
            resourceInputs["externalId"] = state ? state.externalId : undefined;
            resourceInputs["filterTags"] = state ? state.filterTags : undefined;
            resourceInputs["hostTags"] = state ? state.hostTags : undefined;
            resourceInputs["metricsCollectionEnabled"] = state ? state.metricsCollectionEnabled : undefined;
            resourceInputs["resourceCollectionEnabled"] = state ? state.resourceCollectionEnabled : undefined;
            resourceInputs["roleName"] = state ? state.roleName : undefined;
            resourceInputs["secretAccessKey"] = state ? state.secretAccessKey : undefined;
        }
        else {
            const args = argsOrState;
            resourceInputs["accessKeyId"] = args ? args.accessKeyId : undefined;
            resourceInputs["accountId"] = args ? args.accountId : undefined;
            resourceInputs["accountSpecificNamespaceRules"] = args ? args.accountSpecificNamespaceRules : undefined;
            resourceInputs["cspmResourceCollectionEnabled"] = args ? args.cspmResourceCollectionEnabled : undefined;
            resourceInputs["excludedRegions"] = args ? args.excludedRegions : undefined;
            resourceInputs["filterTags"] = args ? args.filterTags : undefined;
            resourceInputs["hostTags"] = args ? args.hostTags : undefined;
            resourceInputs["metricsCollectionEnabled"] = args ? args.metricsCollectionEnabled : undefined;
            resourceInputs["resourceCollectionEnabled"] = args ? args.resourceCollectionEnabled : undefined;
            resourceInputs["roleName"] = args ? args.roleName : undefined;
            resourceInputs["secretAccessKey"] = (args === null || args === void 0 ? void 0 : args.secretAccessKey) ? pulumi.secret(args.secretAccessKey) : undefined;
            resourceInputs["externalId"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        const secretOpts = { additionalSecretOutputs: ["secretAccessKey"] };
        opts = pulumi.mergeOptions(opts, secretOpts);
        super(Integration.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Integration = Integration;
/** @internal */
Integration.__pulumiType = 'datadog:aws/integration:Integration';
//# sourceMappingURL=integration.js.map