"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.IntegrationLambdaArn = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a Datadog - Amazon Web Services integration Lambda ARN resource. This can be used to create and manage the log collection Lambdas for an account.
 *
 * Update operations are currently not supported with datadog API so any change forces a new resource.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Create a new Datadog - Amazon Web Services integration Lambda ARN
 * const mainCollector = new datadog.aws.IntegrationLambdaArn("mainCollector", {
 *     accountId: "1234567890",
 *     lambdaArn: "arn:aws:lambda:us-east-1:1234567890:function:datadog-forwarder-Forwarder",
 * });
 * ```
 *
 * ## Import
 *
 * Amazon Web Services Lambda ARN integrations can be imported using their account_id and lambda_arn separated with a space (` `).
 *
 * ```sh
 *  $ pulumi import datadog:aws/integrationLambdaArn:IntegrationLambdaArn test "1234567890 arn:aws:lambda:us-east-1:1234567890:function:datadog-forwarder-Forwarder"
 * ```
 */
class IntegrationLambdaArn extends pulumi.CustomResource {
    /**
     * Get an existing IntegrationLambdaArn resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new IntegrationLambdaArn(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of IntegrationLambdaArn.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === IntegrationLambdaArn.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["accountId"] = state ? state.accountId : undefined;
            resourceInputs["lambdaArn"] = state ? state.lambdaArn : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.accountId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'accountId'");
            }
            if ((!args || args.lambdaArn === undefined) && !opts.urn) {
                throw new Error("Missing required property 'lambdaArn'");
            }
            resourceInputs["accountId"] = args ? args.accountId : undefined;
            resourceInputs["lambdaArn"] = args ? args.lambdaArn : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(IntegrationLambdaArn.__pulumiType, name, resourceInputs, opts);
    }
}
exports.IntegrationLambdaArn = IntegrationLambdaArn;
/** @internal */
IntegrationLambdaArn.__pulumiType = 'datadog:aws/integrationLambdaArn:IntegrationLambdaArn';
//# sourceMappingURL=integrationLambdaArn.js.map