"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.IntegrationLogCollection = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a Datadog - Amazon Web Services integration log collection resource. This can be used to manage which AWS services logs are collected from for an account.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Create a new Datadog - Amazon Web Services integration log collection
 * const main = new datadog.aws.IntegrationLogCollection("main", {
 *     accountId: "1234567890",
 *     services: ["lambda"],
 * });
 * ```
 *
 * ## Import
 *
 * Amazon Web Services log collection integrations can be imported using the `account ID`.
 *
 * ```sh
 *  $ pulumi import datadog:aws/integrationLogCollection:IntegrationLogCollection test 1234567890
 * ```
 */
class IntegrationLogCollection extends pulumi.CustomResource {
    /**
     * Get an existing IntegrationLogCollection resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new IntegrationLogCollection(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of IntegrationLogCollection.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === IntegrationLogCollection.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["accountId"] = state ? state.accountId : undefined;
            resourceInputs["services"] = state ? state.services : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.accountId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'accountId'");
            }
            if ((!args || args.services === undefined) && !opts.urn) {
                throw new Error("Missing required property 'services'");
            }
            resourceInputs["accountId"] = args ? args.accountId : undefined;
            resourceInputs["services"] = args ? args.services : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(IntegrationLogCollection.__pulumiType, name, resourceInputs, opts);
    }
}
exports.IntegrationLogCollection = IntegrationLogCollection;
/** @internal */
IntegrationLogCollection.__pulumiType = 'datadog:aws/integrationLogCollection:IntegrationLogCollection';
//# sourceMappingURL=integrationLogCollection.js.map