"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.IntegrationTagFilter = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides a Datadog AWS tag filter resource. This can be used to create and manage Datadog AWS tag filters.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Create a new Datadog - Amazon Web Services integration tag filter
 * const foo = new datadog.aws.IntegrationTagFilter("foo", {
 *     accountId: "123456789010",
 *     namespace: "sqs",
 *     tagFilterStr: "key:value",
 * });
 * ```
 *
 * ## Import
 *
 * Amazon Web Services log filter resource can be imported using their account ID and namespace separated with a colon (:).
 *
 * ```sh
 *  $ pulumi import datadog:aws/integrationTagFilter:IntegrationTagFilter foo ${account_id}:${namespace}
 * ```
 */
class IntegrationTagFilter extends pulumi.CustomResource {
    /**
     * Get an existing IntegrationTagFilter resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new IntegrationTagFilter(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of IntegrationTagFilter.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === IntegrationTagFilter.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["accountId"] = state ? state.accountId : undefined;
            resourceInputs["namespace"] = state ? state.namespace : undefined;
            resourceInputs["tagFilterStr"] = state ? state.tagFilterStr : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.accountId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'accountId'");
            }
            if ((!args || args.namespace === undefined) && !opts.urn) {
                throw new Error("Missing required property 'namespace'");
            }
            if ((!args || args.tagFilterStr === undefined) && !opts.urn) {
                throw new Error("Missing required property 'tagFilterStr'");
            }
            resourceInputs["accountId"] = args ? args.accountId : undefined;
            resourceInputs["namespace"] = args ? args.namespace : undefined;
            resourceInputs["tagFilterStr"] = args ? args.tagFilterStr : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(IntegrationTagFilter.__pulumiType, name, resourceInputs, opts);
    }
}
exports.IntegrationTagFilter = IntegrationTagFilter;
/** @internal */
IntegrationTagFilter.__pulumiType = 'datadog:aws/integrationTagFilter:IntegrationTagFilter';
//# sourceMappingURL=integrationTagFilter.js.map