"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudConfigurationRule = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog Cloud Configuration Rule resource.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const myrule = new datadog.CloudConfigurationRule("myrule", {
 *     enabled: true,
 *     groupBies: ["@resource"],
 *     message: "Rule has triggered",
 *     name: "My cloud configuration rule",
 *     notifications: ["@channel"],
 *     policy: `        package datadog
 *
 *         import data.datadog.output as dd_output
 *
 *         import future.keywords.contains
 *         import future.keywords.if
 *         import future.keywords.in
 *
 *         eval(resource) = "skip" if {
 *             # Logic that evaluates to true if the resource should be skipped
 *             true
 *         } else = "pass" {
 *             # Logic that evaluates to true if the resource is compliant
 *             true
 *         } else = "fail" {
 *             # Logic that evaluates to true if the resource is not compliant
 *             true
 *         }
 *
 *         # This part remains unchanged for all rules
 *         results contains result if {
 *             some resource in input.resources[input.main_resource_type]
 *             result := dd_output.format(resource, eval(resource))
 *         }
 *
 * `,
 *     relatedResourceTypes: [],
 *     resourceType: "aws_s3_bucket",
 *     severity: "high",
 *     tags: ["some:tag"],
 * });
 * ```
 *
 * ## Import
 *
 * Security monitoring rules can be imported using ID, e.g.
 *
 * ```sh
 *  $ pulumi import datadog:index/cloudConfigurationRule:CloudConfigurationRule my_rule m0o-hto-lkb
 * ```
 */
class CloudConfigurationRule extends pulumi.CustomResource {
    /**
     * Get an existing CloudConfigurationRule resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new CloudConfigurationRule(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of CloudConfigurationRule.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === CloudConfigurationRule.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["enabled"] = state ? state.enabled : undefined;
            resourceInputs["groupBies"] = state ? state.groupBies : undefined;
            resourceInputs["message"] = state ? state.message : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["notifications"] = state ? state.notifications : undefined;
            resourceInputs["policy"] = state ? state.policy : undefined;
            resourceInputs["relatedResourceTypes"] = state ? state.relatedResourceTypes : undefined;
            resourceInputs["resourceType"] = state ? state.resourceType : undefined;
            resourceInputs["severity"] = state ? state.severity : undefined;
            resourceInputs["tags"] = state ? state.tags : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.enabled === undefined) && !opts.urn) {
                throw new Error("Missing required property 'enabled'");
            }
            if ((!args || args.message === undefined) && !opts.urn) {
                throw new Error("Missing required property 'message'");
            }
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            if ((!args || args.policy === undefined) && !opts.urn) {
                throw new Error("Missing required property 'policy'");
            }
            if ((!args || args.resourceType === undefined) && !opts.urn) {
                throw new Error("Missing required property 'resourceType'");
            }
            if ((!args || args.severity === undefined) && !opts.urn) {
                throw new Error("Missing required property 'severity'");
            }
            resourceInputs["enabled"] = args ? args.enabled : undefined;
            resourceInputs["groupBies"] = args ? args.groupBies : undefined;
            resourceInputs["message"] = args ? args.message : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["notifications"] = args ? args.notifications : undefined;
            resourceInputs["policy"] = args ? args.policy : undefined;
            resourceInputs["relatedResourceTypes"] = args ? args.relatedResourceTypes : undefined;
            resourceInputs["resourceType"] = args ? args.resourceType : undefined;
            resourceInputs["severity"] = args ? args.severity : undefined;
            resourceInputs["tags"] = args ? args.tags : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(CloudConfigurationRule.__pulumiType, name, resourceInputs, opts);
    }
}
exports.CloudConfigurationRule = CloudConfigurationRule;
/** @internal */
CloudConfigurationRule.__pulumiType = 'datadog:index/cloudConfigurationRule:CloudConfigurationRule';
//# sourceMappingURL=cloudConfigurationRule.js.map