"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.CloudWorkloadSecurityAgentRule = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog Cloud Workload Security Agent Rule API resource for agent rules.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const myAgentRule = new datadog.CloudWorkloadSecurityAgentRule("myAgentRule", {
 *     description: "My agent rule",
 *     enabled: true,
 *     expression: "exec.file.name == \"java\"",
 *     name: "my_agent_rule",
 * });
 * ```
 *
 * ## Import
 *
 * Cloud Workload Security Agent rules can be imported using ID, e.g.
 *
 * ```sh
 *  $ pulumi import datadog:index/cloudWorkloadSecurityAgentRule:CloudWorkloadSecurityAgentRule my_agent_rule m0o-hto-lkb
 * ```
 */
class CloudWorkloadSecurityAgentRule extends pulumi.CustomResource {
    /**
     * Get an existing CloudWorkloadSecurityAgentRule resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new CloudWorkloadSecurityAgentRule(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of CloudWorkloadSecurityAgentRule.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === CloudWorkloadSecurityAgentRule.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["description"] = state ? state.description : undefined;
            resourceInputs["enabled"] = state ? state.enabled : undefined;
            resourceInputs["expression"] = state ? state.expression : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.expression === undefined) && !opts.urn) {
                throw new Error("Missing required property 'expression'");
            }
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            resourceInputs["description"] = args ? args.description : undefined;
            resourceInputs["enabled"] = args ? args.enabled : undefined;
            resourceInputs["expression"] = args ? args.expression : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(CloudWorkloadSecurityAgentRule.__pulumiType, name, resourceInputs, opts);
    }
}
exports.CloudWorkloadSecurityAgentRule = CloudWorkloadSecurityAgentRule;
/** @internal */
CloudWorkloadSecurityAgentRule.__pulumiType = 'datadog:index/cloudWorkloadSecurityAgentRule:CloudWorkloadSecurityAgentRule';
//# sourceMappingURL=cloudWorkloadSecurityAgentRule.js.map