/**
 * (Required unless validate is false) Datadog API key. This can also be set via the DD_API_KEY environment variable.
 */
export declare const apiKey: string | undefined;
/**
 * The API URL. This can also be set via the DD_HOST environment variable. Note that this URL must not end with the `/api/`
 * path. For example, `https://api.datadoghq.com/` is a correct value, while `https://api.datadoghq.com/api/` is not. And
 * if you're working with "EU" version of Datadog, use `https://api.datadoghq.eu/`. Other Datadog region examples:
 * `https://api.us5.datadoghq.com/`, `https://api.us3.datadoghq.com/` and `https://api.ddog-gov.com/`. See
 * https://docs.datadoghq.com/getting_started/site/ for all available regions.
 */
export declare const apiUrl: string | undefined;
/**
 * (Required unless validate is false) Datadog APP key. This can also be set via the DD_APP_KEY environment variable.
 */
export declare const appKey: string | undefined;
/**
 * The HTTP request retry back off base. Defaults to 2.
 */
export declare const httpClientRetryBackoffBase: number | undefined;
/**
 * The HTTP request retry back off multiplier. Defaults to 2.
 */
export declare const httpClientRetryBackoffMultiplier: number | undefined;
/**
 * Enables request retries on HTTP status codes 429 and 5xx. Defaults to `true`.
 */
export declare const httpClientRetryEnabled: boolean | undefined;
/**
 * The HTTP request maximum retry number. Defaults to 3.
 */
export declare const httpClientRetryMaxRetries: number | undefined;
/**
 * The HTTP request retry timeout period. Defaults to 60 seconds.
 */
export declare const httpClientRetryTimeout: number | undefined;
/**
 * Enables validation of the provided API and APP keys during provider initialization. Default is true. When false, api_key
 * and app_key won't be checked.
 */
export declare const validate: boolean | undefined;
