"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dashboard = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog dashboard resource. This can be used to create and manage Datadog dashboards.
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/dashboard:Dashboard my_service_dashboard sv7-gyh-kas
 * ```
 */
class Dashboard extends pulumi.CustomResource {
    /**
     * Get an existing Dashboard resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Dashboard(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Dashboard.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Dashboard.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["dashboardLists"] = state ? state.dashboardLists : undefined;
            resourceInputs["dashboardListsRemoveds"] = state ? state.dashboardListsRemoveds : undefined;
            resourceInputs["description"] = state ? state.description : undefined;
            resourceInputs["isReadOnly"] = state ? state.isReadOnly : undefined;
            resourceInputs["layoutType"] = state ? state.layoutType : undefined;
            resourceInputs["notifyLists"] = state ? state.notifyLists : undefined;
            resourceInputs["reflowType"] = state ? state.reflowType : undefined;
            resourceInputs["restrictedRoles"] = state ? state.restrictedRoles : undefined;
            resourceInputs["templateVariablePresets"] = state ? state.templateVariablePresets : undefined;
            resourceInputs["templateVariables"] = state ? state.templateVariables : undefined;
            resourceInputs["title"] = state ? state.title : undefined;
            resourceInputs["url"] = state ? state.url : undefined;
            resourceInputs["widgets"] = state ? state.widgets : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.layoutType === undefined) && !opts.urn) {
                throw new Error("Missing required property 'layoutType'");
            }
            if ((!args || args.title === undefined) && !opts.urn) {
                throw new Error("Missing required property 'title'");
            }
            resourceInputs["dashboardLists"] = args ? args.dashboardLists : undefined;
            resourceInputs["description"] = args ? args.description : undefined;
            resourceInputs["isReadOnly"] = args ? args.isReadOnly : undefined;
            resourceInputs["layoutType"] = args ? args.layoutType : undefined;
            resourceInputs["notifyLists"] = args ? args.notifyLists : undefined;
            resourceInputs["reflowType"] = args ? args.reflowType : undefined;
            resourceInputs["restrictedRoles"] = args ? args.restrictedRoles : undefined;
            resourceInputs["templateVariablePresets"] = args ? args.templateVariablePresets : undefined;
            resourceInputs["templateVariables"] = args ? args.templateVariables : undefined;
            resourceInputs["title"] = args ? args.title : undefined;
            resourceInputs["url"] = args ? args.url : undefined;
            resourceInputs["widgets"] = args ? args.widgets : undefined;
            resourceInputs["dashboardListsRemoveds"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(Dashboard.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Dashboard = Dashboard;
/** @internal */
Dashboard.__pulumiType = 'datadog:index/dashboard:Dashboard';
//# sourceMappingURL=dashboard.js.map