"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.DashboardList = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog dashboardList resource. This can be used to create and manage Datadog Dashboard Lists and the individual dashboards within them.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const time = new datadog.Dashboard("time", {
 *     title: "TF Test Layout Dashboard",
 *     description: "Created using the Datadog provider",
 *     layoutType: "ordered",
 *     isReadOnly: true,
 *     widgets: [{
 *         alertGraphDefinition: {
 *             alertId: "1234",
 *             vizType: "timeseries",
 *             title: "Widget Title",
 *             liveSpan: "1h",
 *         },
 *     }],
 * });
 * const screen = new datadog.Dashboard("screen", {
 *     title: "TF Test Free Layout Dashboard",
 *     description: "Created using the Datadog provider",
 *     layoutType: "free",
 *     isReadOnly: false,
 *     widgets: [{
 *         eventStreamDefinition: {
 *             query: "*",
 *             eventSize: "l",
 *             title: "Widget Title",
 *             titleSize: "16",
 *             titleAlign: "left",
 *             liveSpan: "1h",
 *         },
 *         widgetLayout: {
 *             height: 43,
 *             width: 32,
 *             x: 5,
 *             y: 5,
 *         },
 *     }],
 * });
 * // Create a new Dashboard List with two Dashboards
 * const newList = new datadog.DashboardList("newList", {
 *     name: "Automated Created List",
 *     dashItems: [
 *         {
 *             type: "custom_timeboard",
 *             dashId: time.id,
 *         },
 *         {
 *             type: "custom_screenboard",
 *             dashId: screen.id,
 *         },
 *     ],
 * }, {
 *     dependsOn: [
 *         screen,
 *         time,
 *     ],
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/dashboardList:DashboardList new_list 123456
 * ```
 */
class DashboardList extends pulumi.CustomResource {
    /**
     * Get an existing DashboardList resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new DashboardList(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of DashboardList.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === DashboardList.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["dashItems"] = state ? state.dashItems : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            resourceInputs["dashItems"] = args ? args.dashItems : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(DashboardList.__pulumiType, name, resourceInputs, opts);
    }
}
exports.DashboardList = DashboardList;
/** @internal */
DashboardList.__pulumiType = 'datadog:index/dashboardList:DashboardList';
//# sourceMappingURL=dashboardList.js.map