"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Downtime = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog downtime resource. This can be used to create and manage Datadog downtimes.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Example: downtime for all monitors
 * // Create a new daily 1700-0900 Datadog downtime for all monitors
 * const foo = new datadog.Downtime("foo", {
 *     end: 1483365600,
 *     recurrence: {
 *         period: 1,
 *         type: "days",
 *     },
 *     scopes: ["*"],
 *     start: 1483308000,
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/downtime:Downtime bytes_received_localhost 2081
 * ```
 */
class Downtime extends pulumi.CustomResource {
    /**
     * Get an existing Downtime resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Downtime(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Downtime.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Downtime.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["active"] = state ? state.active : undefined;
            resourceInputs["activeChildId"] = state ? state.activeChildId : undefined;
            resourceInputs["disabled"] = state ? state.disabled : undefined;
            resourceInputs["end"] = state ? state.end : undefined;
            resourceInputs["endDate"] = state ? state.endDate : undefined;
            resourceInputs["message"] = state ? state.message : undefined;
            resourceInputs["monitorId"] = state ? state.monitorId : undefined;
            resourceInputs["monitorTags"] = state ? state.monitorTags : undefined;
            resourceInputs["muteFirstRecoveryNotification"] = state ? state.muteFirstRecoveryNotification : undefined;
            resourceInputs["recurrence"] = state ? state.recurrence : undefined;
            resourceInputs["scopes"] = state ? state.scopes : undefined;
            resourceInputs["start"] = state ? state.start : undefined;
            resourceInputs["startDate"] = state ? state.startDate : undefined;
            resourceInputs["timezone"] = state ? state.timezone : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.scopes === undefined) && !opts.urn) {
                throw new Error("Missing required property 'scopes'");
            }
            resourceInputs["end"] = args ? args.end : undefined;
            resourceInputs["endDate"] = args ? args.endDate : undefined;
            resourceInputs["message"] = args ? args.message : undefined;
            resourceInputs["monitorId"] = args ? args.monitorId : undefined;
            resourceInputs["monitorTags"] = args ? args.monitorTags : undefined;
            resourceInputs["muteFirstRecoveryNotification"] = args ? args.muteFirstRecoveryNotification : undefined;
            resourceInputs["recurrence"] = args ? args.recurrence : undefined;
            resourceInputs["scopes"] = args ? args.scopes : undefined;
            resourceInputs["start"] = args ? args.start : undefined;
            resourceInputs["startDate"] = args ? args.startDate : undefined;
            resourceInputs["timezone"] = args ? args.timezone : undefined;
            resourceInputs["active"] = undefined /*out*/;
            resourceInputs["activeChildId"] = undefined /*out*/;
            resourceInputs["disabled"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(Downtime.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Downtime = Downtime;
/** @internal */
Downtime.__pulumiType = 'datadog:index/downtime:Downtime';
//# sourceMappingURL=downtime.js.map