import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve information about existing Cloud Workload Security Agent Rules for use in other resources.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const test = datadog.getCloudWorkloadSecurityAgentRules({});
 * ```
 */
export declare function getCloudWorkloadSecurityAgentRules(opts?: pulumi.InvokeOptions): Promise<GetCloudWorkloadSecurityAgentRulesResult>;
/**
 * A collection of values returned by getCloudWorkloadSecurityAgentRules.
 */
export interface GetCloudWorkloadSecurityAgentRulesResult {
    /**
     * List of Agent rules.
     */
    readonly agentRules: outputs.GetCloudWorkloadSecurityAgentRulesAgentRule[];
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
}
