"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDashboardListOutput = exports.getDashboardList = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Use this data source to retrieve information about an existing dashboard list, for use in other resources. In particular, it can be used in a dashboard to register it in the list.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const test = datadog.getDashboardList({
 *     name: "My super list",
 * });
 * // Create a dashboard and register it in the list above.
 * const time = new datadog.Dashboard("time", {
 *     dashboardLists: [test.then(test => test.id)],
 *     description: "Created using the Datadog provider in Terraform",
 *     isReadOnly: true,
 *     layoutType: "ordered",
 *     title: "TF Test Layout Dashboard",
 *     widgets: [{
 *         alertGraphDefinition: {
 *             alertId: "1234",
 *             liveSpan: "1h",
 *             title: "Widget Title",
 *             vizType: "timeseries",
 *         },
 *     }],
 * });
 * ```
 */
function getDashboardList(args, opts) {
    opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts || {});
    return pulumi.runtime.invoke("datadog:index/getDashboardList:getDashboardList", {
        "name": args.name,
    }, opts);
}
exports.getDashboardList = getDashboardList;
/**
 * Use this data source to retrieve information about an existing dashboard list, for use in other resources. In particular, it can be used in a dashboard to register it in the list.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const test = datadog.getDashboardList({
 *     name: "My super list",
 * });
 * // Create a dashboard and register it in the list above.
 * const time = new datadog.Dashboard("time", {
 *     dashboardLists: [test.then(test => test.id)],
 *     description: "Created using the Datadog provider in Terraform",
 *     isReadOnly: true,
 *     layoutType: "ordered",
 *     title: "TF Test Layout Dashboard",
 *     widgets: [{
 *         alertGraphDefinition: {
 *             alertId: "1234",
 *             liveSpan: "1h",
 *             title: "Widget Title",
 *             vizType: "timeseries",
 *         },
 *     }],
 * });
 * ```
 */
function getDashboardListOutput(args, opts) {
    return pulumi.output(args).apply((a) => getDashboardList(a, opts));
}
exports.getDashboardListOutput = getDashboardListOutput;
//# sourceMappingURL=getDashboardList.js.map