import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to list several existing logs indexes for use in other resources.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const test = datadog.getLogsIndexes({});
 * ```
 */
export declare function getLogsIndexes(opts?: pulumi.InvokeOptions): Promise<GetLogsIndexesResult>;
/**
 * A collection of values returned by getLogsIndexes.
 */
export interface GetLogsIndexesResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * List of logs indexes
     */
    readonly logsIndexes: outputs.GetLogsIndexesLogsIndex[];
}
