import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to list all existing logs pipelines for use in other resources.
 */
export declare function getLogsPipelines(args?: GetLogsPipelinesArgs, opts?: pulumi.InvokeOptions): Promise<GetLogsPipelinesResult>;
/**
 * A collection of arguments for invoking getLogsPipelines.
 */
export interface GetLogsPipelinesArgs {
    /**
     * Filter parameter for retrieved pipelines
     */
    isReadOnly?: string;
}
/**
 * A collection of values returned by getLogsPipelines.
 */
export interface GetLogsPipelinesResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * Filter parameter for retrieved pipelines
     */
    readonly isReadOnly?: string;
    /**
     * List of logs pipelines
     */
    readonly logsPipelines: outputs.GetLogsPipelinesLogsPipeline[];
}
/**
 * Use this data source to list all existing logs pipelines for use in other resources.
 */
export declare function getLogsPipelinesOutput(args?: GetLogsPipelinesOutputArgs, opts?: pulumi.InvokeOptions): pulumi.Output<GetLogsPipelinesResult>;
/**
 * A collection of arguments for invoking getLogsPipelines.
 */
export interface GetLogsPipelinesOutputArgs {
    /**
     * Filter parameter for retrieved pipelines
     */
    isReadOnly?: pulumi.Input<string>;
}
