import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to list existing monitor config policies for use in other resources.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const test = datadog.getMonitorConfigPolicies({});
 * ```
 */
export declare function getMonitorConfigPolicies(opts?: pulumi.InvokeOptions): Promise<GetMonitorConfigPoliciesResult>;
/**
 * A collection of values returned by getMonitorConfigPolicies.
 */
export interface GetMonitorConfigPoliciesResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * List of monitor config policies
     */
    readonly monitorConfigPolicies: outputs.GetMonitorConfigPoliciesMonitorConfigPolicy[];
}
