import * as pulumi from "@pulumi/pulumi";
import * as outputs from "./types/output";
/**
 * Use this data source to retrieve information about existing security monitoring filters for use in other resources.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const test = datadog.getSecurityMonitoringFilters({});
 * ```
 */
export declare function getSecurityMonitoringFilters(opts?: pulumi.InvokeOptions): Promise<GetSecurityMonitoringFiltersResult>;
/**
 * A collection of values returned by getSecurityMonitoringFilters.
 */
export interface GetSecurityMonitoringFiltersResult {
    /**
     * List of filters.
     */
    readonly filters: outputs.GetSecurityMonitoringFiltersFilter[];
    /**
     * List of IDs of filters.
     */
    readonly filtersIds: string[];
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
}
