import * as pulumi from "@pulumi/pulumi";
/**
 * Use this data source to retrieve a Datadog Synthetics global variable (to be used in Synthetics tests).
 */
export declare function getSyntheticsGlobalVariable(args: GetSyntheticsGlobalVariableArgs, opts?: pulumi.InvokeOptions): Promise<GetSyntheticsGlobalVariableResult>;
/**
 * A collection of arguments for invoking getSyntheticsGlobalVariable.
 */
export interface GetSyntheticsGlobalVariableArgs {
    /**
     * The synthetics global variable name to search for. Must only match one global variable.
     */
    name: string;
}
/**
 * A collection of values returned by getSyntheticsGlobalVariable.
 */
export interface GetSyntheticsGlobalVariableResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * The synthetics global variable name to search for. Must only match one global variable.
     */
    readonly name: string;
    /**
     * A list of tags assigned to the Synthetics global variable.
     */
    readonly tags: string[];
}
/**
 * Use this data source to retrieve a Datadog Synthetics global variable (to be used in Synthetics tests).
 */
export declare function getSyntheticsGlobalVariableOutput(args: GetSyntheticsGlobalVariableOutputArgs, opts?: pulumi.InvokeOptions): pulumi.Output<GetSyntheticsGlobalVariableResult>;
/**
 * A collection of arguments for invoking getSyntheticsGlobalVariable.
 */
export interface GetSyntheticsGlobalVariableOutputArgs {
    /**
     * The synthetics global variable name to search for. Must only match one global variable.
     */
    name: pulumi.Input<string>;
}
