import * as pulumi from "@pulumi/pulumi";
/**
 * Use this data source to retrieve Datadog's Synthetics Locations (to be used in Synthetics tests).
 */
export declare function getSyntheticsLocations(opts?: pulumi.InvokeOptions): Promise<GetSyntheticsLocationsResult>;
/**
 * A collection of values returned by getSyntheticsLocations.
 */
export interface GetSyntheticsLocationsResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * A map of available Synthetics location IDs to names for Synthetics tests.
     */
    readonly locations: {
        [key: string]: any;
    };
}
