import * as pulumi from "@pulumi/pulumi";
/**
 * Use this data source to retrieve a Datadog Synthetic Test.
 */
export declare function getSyntheticsTest(args: GetSyntheticsTestArgs, opts?: pulumi.InvokeOptions): Promise<GetSyntheticsTestResult>;
/**
 * A collection of arguments for invoking getSyntheticsTest.
 */
export interface GetSyntheticsTestArgs {
    /**
     * The synthetic test id to search for
     */
    testId: string;
}
/**
 * A collection of values returned by getSyntheticsTest.
 */
export interface GetSyntheticsTestResult {
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * The name of the synthetic test.
     */
    readonly name: string;
    /**
     * A list of tags assigned to the synthetic test.
     */
    readonly tags: string[];
    /**
     * The synthetic test id to search for
     */
    readonly testId: string;
    /**
     * The start URL of the synthetic test.
     */
    readonly url: string;
}
/**
 * Use this data source to retrieve a Datadog Synthetic Test.
 */
export declare function getSyntheticsTestOutput(args: GetSyntheticsTestOutputArgs, opts?: pulumi.InvokeOptions): pulumi.Output<GetSyntheticsTestResult>;
/**
 * A collection of arguments for invoking getSyntheticsTest.
 */
export interface GetSyntheticsTestOutputArgs {
    /**
     * The synthetic test id to search for
     */
    testId: pulumi.Input<string>;
}
