import * as pulumi from "@pulumi/pulumi";
/**
 * Use this data source to retrieve information about an existing user to use it in an other resources.
 */
export declare function getUser(args: GetUserArgs, opts?: pulumi.InvokeOptions): Promise<GetUserResult>;
/**
 * A collection of arguments for invoking getUser.
 */
export interface GetUserArgs {
    /**
     * Filter all users by the given string.
     */
    filter: string;
}
/**
 * A collection of values returned by getUser.
 */
export interface GetUserResult {
    /**
     * Email of the user.
     */
    readonly email: string;
    /**
     * Filter all users by the given string.
     */
    readonly filter: string;
    /**
     * The provider-assigned unique ID for this managed resource.
     */
    readonly id: string;
    /**
     * Name of the user.
     */
    readonly name: string;
}
/**
 * Use this data source to retrieve information about an existing user to use it in an other resources.
 */
export declare function getUserOutput(args: GetUserOutputArgs, opts?: pulumi.InvokeOptions): pulumi.Output<GetUserResult>;
/**
 * A collection of arguments for invoking getUser.
 */
export interface GetUserOutputArgs {
    /**
     * Filter all users by the given string.
     */
    filter: pulumi.Input<string>;
}
