"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogsArchive = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog Logs Archive API resource, which is used to create and manage Datadog logs archives.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const myS3Archive = new datadog.LogsArchive("myS3Archive", {
 *     name: "my s3 archive",
 *     query: "service:myservice",
 *     s3Archive: {
 *         accountId: "001234567888",
 *         bucket: "my-bucket",
 *         path: "/path/foo",
 *         roleName: "my-role-name",
 *     },
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/logsArchive:LogsArchive my_s3_archive 1Aabc2_dfQPLnXy3HlfK4hi
 * ```
 */
class LogsArchive extends pulumi.CustomResource {
    /**
     * Get an existing LogsArchive resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new LogsArchive(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of LogsArchive.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === LogsArchive.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["azureArchive"] = state ? state.azureArchive : undefined;
            resourceInputs["gcsArchive"] = state ? state.gcsArchive : undefined;
            resourceInputs["includeTags"] = state ? state.includeTags : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["query"] = state ? state.query : undefined;
            resourceInputs["rehydrationMaxScanSizeInGb"] = state ? state.rehydrationMaxScanSizeInGb : undefined;
            resourceInputs["rehydrationTags"] = state ? state.rehydrationTags : undefined;
            resourceInputs["s3Archive"] = state ? state.s3Archive : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            if ((!args || args.query === undefined) && !opts.urn) {
                throw new Error("Missing required property 'query'");
            }
            resourceInputs["azureArchive"] = args ? args.azureArchive : undefined;
            resourceInputs["gcsArchive"] = args ? args.gcsArchive : undefined;
            resourceInputs["includeTags"] = args ? args.includeTags : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["query"] = args ? args.query : undefined;
            resourceInputs["rehydrationMaxScanSizeInGb"] = args ? args.rehydrationMaxScanSizeInGb : undefined;
            resourceInputs["rehydrationTags"] = args ? args.rehydrationTags : undefined;
            resourceInputs["s3Archive"] = args ? args.s3Archive : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(LogsArchive.__pulumiType, name, resourceInputs, opts);
    }
}
exports.LogsArchive = LogsArchive;
/** @internal */
LogsArchive.__pulumiType = 'datadog:index/logsArchive:LogsArchive';
//# sourceMappingURL=logsArchive.js.map