"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogsArchiveOrder = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog [Logs Archive API](https://docs.datadoghq.com/api/v2/logs-archives/) resource, which is used to manage Datadog log archives order.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const sampleArchiveOrder = new datadog.LogsArchiveOrder("sampleArchiveOrder", {archiveIds: [
 *     datadog_logs_archive.sample_archive_1.id,
 *     datadog_logs_archive.sample_archive_2.id,
 * ]});
 * ```
 *
 * ## Import
 *
 * There must be at most one datadog_logs_archive_order resource. You can import the datadog_logs_archive_order or create an archive order.
 *
 * ```sh
 *  $ pulumi import datadog:index/logsArchiveOrder:LogsArchiveOrder name> archiveOrderID
 * ```
 */
class LogsArchiveOrder extends pulumi.CustomResource {
    /**
     * Get an existing LogsArchiveOrder resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new LogsArchiveOrder(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of LogsArchiveOrder.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === LogsArchiveOrder.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["archiveIds"] = state ? state.archiveIds : undefined;
        }
        else {
            const args = argsOrState;
            resourceInputs["archiveIds"] = args ? args.archiveIds : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(LogsArchiveOrder.__pulumiType, name, resourceInputs, opts);
    }
}
exports.LogsArchiveOrder = LogsArchiveOrder;
/** @internal */
LogsArchiveOrder.__pulumiType = 'datadog:index/logsArchiveOrder:LogsArchiveOrder';
//# sourceMappingURL=logsArchiveOrder.js.map