"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogsIndex = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const sampleIndex = new datadog.LogsIndex("sampleIndex", {
 *     dailyLimit: 200000,
 *     exclusionFilters: [
 *         {
 *             filters: [{
 *                 query: "app:coredns",
 *                 sampleRate: 0.97,
 *             }],
 *             isEnabled: true,
 *             name: "Filter coredns logs",
 *         },
 *         {
 *             filters: [{
 *                 query: "service:kube_apiserver",
 *                 sampleRate: 1,
 *             }],
 *             isEnabled: true,
 *             name: "Kubernetes apiserver",
 *         },
 *     ],
 *     filters: [{
 *         query: "*",
 *     }],
 *     name: "your index",
 *     retentionDays: 7,
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/logsIndex:LogsIndex name> <indexName>
 * ```
 */
class LogsIndex extends pulumi.CustomResource {
    /**
     * Get an existing LogsIndex resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new LogsIndex(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of LogsIndex.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === LogsIndex.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["dailyLimit"] = state ? state.dailyLimit : undefined;
            resourceInputs["disableDailyLimit"] = state ? state.disableDailyLimit : undefined;
            resourceInputs["exclusionFilters"] = state ? state.exclusionFilters : undefined;
            resourceInputs["filters"] = state ? state.filters : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["retentionDays"] = state ? state.retentionDays : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.filters === undefined) && !opts.urn) {
                throw new Error("Missing required property 'filters'");
            }
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            resourceInputs["dailyLimit"] = args ? args.dailyLimit : undefined;
            resourceInputs["disableDailyLimit"] = args ? args.disableDailyLimit : undefined;
            resourceInputs["exclusionFilters"] = args ? args.exclusionFilters : undefined;
            resourceInputs["filters"] = args ? args.filters : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["retentionDays"] = args ? args.retentionDays : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(LogsIndex.__pulumiType, name, resourceInputs, opts);
    }
}
exports.LogsIndex = LogsIndex;
/** @internal */
LogsIndex.__pulumiType = 'datadog:index/logsIndex:LogsIndex';
//# sourceMappingURL=logsIndex.js.map