"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogsIndexOrder = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog Logs Index API resource. This can be used to manage the order of Datadog logs indexes.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const sampleIndexOrder = new datadog.LogsIndexOrder("sampleIndexOrder", {
 *     name: "sample_index_order",
 *     indexes: [datadog_logs_index.sample_index.id],
 * });
 * ```
 *
 * ## Import
 *
 * The Datadog Terraform Provider does not support the creation and deletion of index orders. There must be at most one `datadog_logs_index_order` resource `<name>` can be whatever you specify in your code. Datadog does not store the name on the server.
 *
 * ```sh
 *  $ pulumi import datadog:index/logsIndexOrder:LogsIndexOrder name> <name>
 * ```
 */
class LogsIndexOrder extends pulumi.CustomResource {
    /**
     * Get an existing LogsIndexOrder resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new LogsIndexOrder(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of LogsIndexOrder.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === LogsIndexOrder.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["indexes"] = state ? state.indexes : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.indexes === undefined) && !opts.urn) {
                throw new Error("Missing required property 'indexes'");
            }
            resourceInputs["indexes"] = args ? args.indexes : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(LogsIndexOrder.__pulumiType, name, resourceInputs, opts);
    }
}
exports.LogsIndexOrder = LogsIndexOrder;
/** @internal */
LogsIndexOrder.__pulumiType = 'datadog:index/logsIndexOrder:LogsIndexOrder';
//# sourceMappingURL=logsIndexOrder.js.map