"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogsMetric = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Resource for interacting with the logsMetric API
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const testingLogsMetric = new datadog.LogsMetric("testingLogsMetric", {
 *     compute: {
 *         aggregationType: "distribution",
 *         path: "@duration",
 *     },
 *     filter: {
 *         query: "service:test",
 *     },
 *     groupBies: [
 *         {
 *             path: "@status",
 *             tagName: "status",
 *         },
 *         {
 *             path: "@version",
 *             tagName: "version",
 *         },
 *     ],
 *     name: "testing.logs.metric",
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/logsMetric:LogsMetric testing_logs_metric testing.logs.metric
 * ```
 */
class LogsMetric extends pulumi.CustomResource {
    /**
     * Get an existing LogsMetric resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new LogsMetric(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of LogsMetric.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === LogsMetric.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["compute"] = state ? state.compute : undefined;
            resourceInputs["filter"] = state ? state.filter : undefined;
            resourceInputs["groupBies"] = state ? state.groupBies : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.compute === undefined) && !opts.urn) {
                throw new Error("Missing required property 'compute'");
            }
            if ((!args || args.filter === undefined) && !opts.urn) {
                throw new Error("Missing required property 'filter'");
            }
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            resourceInputs["compute"] = args ? args.compute : undefined;
            resourceInputs["filter"] = args ? args.filter : undefined;
            resourceInputs["groupBies"] = args ? args.groupBies : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(LogsMetric.__pulumiType, name, resourceInputs, opts);
    }
}
exports.LogsMetric = LogsMetric;
/** @internal */
LogsMetric.__pulumiType = 'datadog:index/logsMetric:LogsMetric';
//# sourceMappingURL=logsMetric.js.map