"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogsPipelineOrder = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog Logs Pipeline API resource, which is used to manage Datadog log pipelines order.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const samplePipelineOrder = new datadog.LogsPipelineOrder("samplePipelineOrder", {
 *     name: "sample_pipeline_order",
 *     pipelines: [
 *         datadog_logs_custom_pipeline.sample_pipeline.id,
 *         datadog_logs_integration_pipeline.python.id,
 *     ],
 * });
 * ```
 *
 * ## Import
 *
 * There must be at most one datadog_logs_pipeline_order resource. Pipeline order creation is not supported from logs config API. You can import the datadog_logs_pipeline_order or create a pipeline order (which is actually doing the update operation).
 *
 * ```sh
 *  $ pulumi import datadog:index/logsPipelineOrder:LogsPipelineOrder name> <name>
 * ```
 */
class LogsPipelineOrder extends pulumi.CustomResource {
    /**
     * Get an existing LogsPipelineOrder resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new LogsPipelineOrder(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of LogsPipelineOrder.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === LogsPipelineOrder.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["pipelines"] = state ? state.pipelines : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            if ((!args || args.pipelines === undefined) && !opts.urn) {
                throw new Error("Missing required property 'pipelines'");
            }
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["pipelines"] = args ? args.pipelines : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(LogsPipelineOrder.__pulumiType, name, resourceInputs, opts);
    }
}
exports.LogsPipelineOrder = LogsPipelineOrder;
/** @internal */
LogsPipelineOrder.__pulumiType = 'datadog:index/logsPipelineOrder:LogsPipelineOrder';
//# sourceMappingURL=logsPipelineOrder.js.map