"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetricMetadata = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog metricMetadata resource. This can be used to manage a metric's metadata.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Manage a Datadog metric's metadata
 * const requestTime = new datadog.MetricMetadata("requestTime", {
 *     description: "99th percentile request time in millseconds",
 *     metric: "request.time",
 *     shortName: "Request time",
 *     type: "gauge",
 *     unit: "millisecond",
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/metricMetadata:MetricMetadata request_time request.time
 * ```
 */
class MetricMetadata extends pulumi.CustomResource {
    /**
     * Get an existing MetricMetadata resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new MetricMetadata(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of MetricMetadata.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === MetricMetadata.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["description"] = state ? state.description : undefined;
            resourceInputs["metric"] = state ? state.metric : undefined;
            resourceInputs["perUnit"] = state ? state.perUnit : undefined;
            resourceInputs["shortName"] = state ? state.shortName : undefined;
            resourceInputs["statsdInterval"] = state ? state.statsdInterval : undefined;
            resourceInputs["type"] = state ? state.type : undefined;
            resourceInputs["unit"] = state ? state.unit : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.metric === undefined) && !opts.urn) {
                throw new Error("Missing required property 'metric'");
            }
            resourceInputs["description"] = args ? args.description : undefined;
            resourceInputs["metric"] = args ? args.metric : undefined;
            resourceInputs["perUnit"] = args ? args.perUnit : undefined;
            resourceInputs["shortName"] = args ? args.shortName : undefined;
            resourceInputs["statsdInterval"] = args ? args.statsdInterval : undefined;
            resourceInputs["type"] = args ? args.type : undefined;
            resourceInputs["unit"] = args ? args.unit : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(MetricMetadata.__pulumiType, name, resourceInputs, opts);
    }
}
exports.MetricMetadata = MetricMetadata;
/** @internal */
MetricMetadata.__pulumiType = 'datadog:index/metricMetadata:MetricMetadata';
//# sourceMappingURL=metricMetadata.js.map