"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetricTagConfiguration = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog metric tag configuration resource. This can be used to modify tag configurations for metrics.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Manage a tag configuration for a Datadog distribution metric with/without percentiles
 * const exampleDistMetric = new datadog.MetricTagConfiguration("exampleDistMetric", {
 *     includePercentiles: false,
 *     metricName: "example.terraform.dist.metric",
 *     metricType: "distribution",
 *     tags: [
 *         "sport",
 *         "datacenter",
 *     ],
 * });
 * // Manage tag configurations for a Datadog count or gauge metric
 * const exampleCountMetric = new datadog.MetricTagConfiguration("exampleCountMetric", {
 *     aggregations: [
 *         {
 *             space: "min",
 *             time: "avg",
 *         },
 *         {
 *             space: "max",
 *             time: "avg",
 *         },
 *     ],
 *     metricName: "example.terraform.count.metric",
 *     metricType: "count",
 *     tags: [
 *         "sport",
 *         "datacenter",
 *     ],
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/metricTagConfiguration:MetricTagConfiguration example_dist_metric example.terraform.dist.metric
 * ```
 */
class MetricTagConfiguration extends pulumi.CustomResource {
    /**
     * Get an existing MetricTagConfiguration resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new MetricTagConfiguration(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of MetricTagConfiguration.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === MetricTagConfiguration.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["aggregations"] = state ? state.aggregations : undefined;
            resourceInputs["includePercentiles"] = state ? state.includePercentiles : undefined;
            resourceInputs["metricName"] = state ? state.metricName : undefined;
            resourceInputs["metricType"] = state ? state.metricType : undefined;
            resourceInputs["tags"] = state ? state.tags : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.metricName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'metricName'");
            }
            if ((!args || args.metricType === undefined) && !opts.urn) {
                throw new Error("Missing required property 'metricType'");
            }
            if ((!args || args.tags === undefined) && !opts.urn) {
                throw new Error("Missing required property 'tags'");
            }
            resourceInputs["aggregations"] = args ? args.aggregations : undefined;
            resourceInputs["includePercentiles"] = args ? args.includePercentiles : undefined;
            resourceInputs["metricName"] = args ? args.metricName : undefined;
            resourceInputs["metricType"] = args ? args.metricType : undefined;
            resourceInputs["tags"] = args ? args.tags : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(MetricTagConfiguration.__pulumiType, name, resourceInputs, opts);
    }
}
exports.MetricTagConfiguration = MetricTagConfiguration;
/** @internal */
MetricTagConfiguration.__pulumiType = 'datadog:index/metricTagConfiguration:MetricTagConfiguration';
//# sourceMappingURL=metricTagConfiguration.js.map