"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Monitor = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog monitor resource. This can be used to create and manage Datadog monitors.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const foo = new datadog.Monitor("foo", {
 *     escalationMessage: "Escalation message @pagerduty",
 *     includeTags: true,
 *     message: "Monitor triggered. Notify: @hipchat-channel",
 *     monitorThresholds: {
 *         critical: "4",
 *         warning: "2",
 *     },
 *     name: "Name for monitor foo",
 *     query: "avg(last_1h):avg:aws.ec2.cpu{environment:foo,host:foo} by {host} > 4",
 *     tags: [
 *         "foo:bar",
 *         "team:fooBar",
 *     ],
 *     type: "metric alert",
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/monitor:Monitor bytes_received_localhost 2081
 * ```
 */
class Monitor extends pulumi.CustomResource {
    /**
     * Get an existing Monitor resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Monitor(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Monitor.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Monitor.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["enableLogsSample"] = state ? state.enableLogsSample : undefined;
            resourceInputs["enableSamples"] = state ? state.enableSamples : undefined;
            resourceInputs["escalationMessage"] = state ? state.escalationMessage : undefined;
            resourceInputs["evaluationDelay"] = state ? state.evaluationDelay : undefined;
            resourceInputs["forceDelete"] = state ? state.forceDelete : undefined;
            resourceInputs["groupRetentionDuration"] = state ? state.groupRetentionDuration : undefined;
            resourceInputs["groupbySimpleMonitor"] = state ? state.groupbySimpleMonitor : undefined;
            resourceInputs["includeTags"] = state ? state.includeTags : undefined;
            resourceInputs["locked"] = state ? state.locked : undefined;
            resourceInputs["message"] = state ? state.message : undefined;
            resourceInputs["monitorThresholdWindows"] = state ? state.monitorThresholdWindows : undefined;
            resourceInputs["monitorThresholds"] = state ? state.monitorThresholds : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["newGroupDelay"] = state ? state.newGroupDelay : undefined;
            resourceInputs["newHostDelay"] = state ? state.newHostDelay : undefined;
            resourceInputs["noDataTimeframe"] = state ? state.noDataTimeframe : undefined;
            resourceInputs["notificationPresetName"] = state ? state.notificationPresetName : undefined;
            resourceInputs["notifyAudit"] = state ? state.notifyAudit : undefined;
            resourceInputs["notifyBies"] = state ? state.notifyBies : undefined;
            resourceInputs["notifyNoData"] = state ? state.notifyNoData : undefined;
            resourceInputs["onMissingData"] = state ? state.onMissingData : undefined;
            resourceInputs["priority"] = state ? state.priority : undefined;
            resourceInputs["query"] = state ? state.query : undefined;
            resourceInputs["renotifyInterval"] = state ? state.renotifyInterval : undefined;
            resourceInputs["renotifyOccurrences"] = state ? state.renotifyOccurrences : undefined;
            resourceInputs["renotifyStatuses"] = state ? state.renotifyStatuses : undefined;
            resourceInputs["requireFullWindow"] = state ? state.requireFullWindow : undefined;
            resourceInputs["restrictedRoles"] = state ? state.restrictedRoles : undefined;
            resourceInputs["schedulingOptions"] = state ? state.schedulingOptions : undefined;
            resourceInputs["tags"] = state ? state.tags : undefined;
            resourceInputs["timeoutH"] = state ? state.timeoutH : undefined;
            resourceInputs["type"] = state ? state.type : undefined;
            resourceInputs["validate"] = state ? state.validate : undefined;
            resourceInputs["variables"] = state ? state.variables : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.message === undefined) && !opts.urn) {
                throw new Error("Missing required property 'message'");
            }
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            if ((!args || args.query === undefined) && !opts.urn) {
                throw new Error("Missing required property 'query'");
            }
            if ((!args || args.type === undefined) && !opts.urn) {
                throw new Error("Missing required property 'type'");
            }
            resourceInputs["enableLogsSample"] = args ? args.enableLogsSample : undefined;
            resourceInputs["escalationMessage"] = args ? args.escalationMessage : undefined;
            resourceInputs["evaluationDelay"] = args ? args.evaluationDelay : undefined;
            resourceInputs["forceDelete"] = args ? args.forceDelete : undefined;
            resourceInputs["groupRetentionDuration"] = args ? args.groupRetentionDuration : undefined;
            resourceInputs["groupbySimpleMonitor"] = args ? args.groupbySimpleMonitor : undefined;
            resourceInputs["includeTags"] = args ? args.includeTags : undefined;
            resourceInputs["locked"] = args ? args.locked : undefined;
            resourceInputs["message"] = args ? args.message : undefined;
            resourceInputs["monitorThresholdWindows"] = args ? args.monitorThresholdWindows : undefined;
            resourceInputs["monitorThresholds"] = args ? args.monitorThresholds : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["newGroupDelay"] = args ? args.newGroupDelay : undefined;
            resourceInputs["newHostDelay"] = args ? args.newHostDelay : undefined;
            resourceInputs["noDataTimeframe"] = args ? args.noDataTimeframe : undefined;
            resourceInputs["notificationPresetName"] = args ? args.notificationPresetName : undefined;
            resourceInputs["notifyAudit"] = args ? args.notifyAudit : undefined;
            resourceInputs["notifyBies"] = args ? args.notifyBies : undefined;
            resourceInputs["notifyNoData"] = args ? args.notifyNoData : undefined;
            resourceInputs["onMissingData"] = args ? args.onMissingData : undefined;
            resourceInputs["priority"] = args ? args.priority : undefined;
            resourceInputs["query"] = args ? args.query : undefined;
            resourceInputs["renotifyInterval"] = args ? args.renotifyInterval : undefined;
            resourceInputs["renotifyOccurrences"] = args ? args.renotifyOccurrences : undefined;
            resourceInputs["renotifyStatuses"] = args ? args.renotifyStatuses : undefined;
            resourceInputs["requireFullWindow"] = args ? args.requireFullWindow : undefined;
            resourceInputs["restrictedRoles"] = args ? args.restrictedRoles : undefined;
            resourceInputs["schedulingOptions"] = args ? args.schedulingOptions : undefined;
            resourceInputs["tags"] = args ? args.tags : undefined;
            resourceInputs["timeoutH"] = args ? args.timeoutH : undefined;
            resourceInputs["type"] = args ? args.type : undefined;
            resourceInputs["validate"] = args ? args.validate : undefined;
            resourceInputs["variables"] = args ? args.variables : undefined;
            resourceInputs["enableSamples"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(Monitor.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Monitor = Monitor;
/** @internal */
Monitor.__pulumiType = 'datadog:index/monitor:Monitor';
//# sourceMappingURL=monitor.js.map