"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.MonitorConfigPolicy = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog monitor config policy resource. This can be used to create and manage Datadog monitor config policies.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const test = new datadog.MonitorConfigPolicy("test", {
 *     policyType: "tag",
 *     tagPolicy: {
 *         tagKey: "env",
 *         tagKeyRequired: false,
 *         validTagValues: [
 *             "staging",
 *             "prod",
 *         ],
 *     },
 * });
 * ```
 */
class MonitorConfigPolicy extends pulumi.CustomResource {
    /**
     * Get an existing MonitorConfigPolicy resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new MonitorConfigPolicy(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of MonitorConfigPolicy.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === MonitorConfigPolicy.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["policyType"] = state ? state.policyType : undefined;
            resourceInputs["tagPolicy"] = state ? state.tagPolicy : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.policyType === undefined) && !opts.urn) {
                throw new Error("Missing required property 'policyType'");
            }
            resourceInputs["policyType"] = args ? args.policyType : undefined;
            resourceInputs["tagPolicy"] = args ? args.tagPolicy : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(MonitorConfigPolicy.__pulumiType, name, resourceInputs, opts);
    }
}
exports.MonitorConfigPolicy = MonitorConfigPolicy;
/** @internal */
MonitorConfigPolicy.__pulumiType = 'datadog:index/monitorConfigPolicy:MonitorConfigPolicy';
//# sourceMappingURL=monitorConfigPolicy.js.map