"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.MonitorJson = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog monitor JSON resource. This can be used to create and manage Datadog monitors using the JSON definition.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const monitorJson = new datadog.MonitorJson("monitorJson", {monitor: `{
 *     "name": "Example monitor - service check",
 *     "type": "service check",
 *     "query": "\\"ntp.in_sync\\".by(\\"*\\").last(2).count_by_status()",
 *     "message": "Change the message triggers if any host's clock goes out of sync with the time given by NTP. The offset threshold is configured in the Agent's 'ntp.yaml' file.\\n\\nSee [Troubleshooting NTP Offset issues](https://docs.datadoghq.com/agent/troubleshooting/ntp for more details on cause and resolution.",
 *     "tags": [],
 *     "multi": true,
 * 	"restricted_roles": null,
 *     "options": {
 *         "include_tags": true,
 *         "locked": false,
 *         "new_host_delay": 150,
 *         "notify_audit": false,
 *         "notify_no_data": false,
 *         "thresholds": {
 *             "warning": 1,
 *             "ok": 1,
 *             "critical": 1
 *         }
 *     },
 *     "priority": null,
 *     "classification": "custom"
 * }
 * `});
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/monitorJson:MonitorJson monitor_json 123456
 * ```
 */
class MonitorJson extends pulumi.CustomResource {
    /**
     * Get an existing MonitorJson resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new MonitorJson(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of MonitorJson.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === MonitorJson.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["monitor"] = state ? state.monitor : undefined;
            resourceInputs["url"] = state ? state.url : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.monitor === undefined) && !opts.urn) {
                throw new Error("Missing required property 'monitor'");
            }
            resourceInputs["monitor"] = args ? args.monitor : undefined;
            resourceInputs["url"] = args ? args.url : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(MonitorJson.__pulumiType, name, resourceInputs, opts);
    }
}
exports.MonitorJson = MonitorJson;
/** @internal */
MonitorJson.__pulumiType = 'datadog:index/monitorJson:MonitorJson';
//# sourceMappingURL=monitorJson.js.map