"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceObject = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Resource for interacting with Datadog Opsgenie Service API.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const fakeServiceName = new datadog.opsgenie.ServiceObject("fakeServiceName", {
 *     name: "fake_service_name",
 *     opsgenieApiKey: "00000000-0000-0000-0000-000000000000",
 *     region: "us",
 * });
 * const fakeServiceName2 = new datadog.opsgenie.ServiceObject("fakeServiceName2", {
 *     name: "fake_service_name_2",
 *     opsgenieApiKey: "11111111-1111-1111-1111-111111111111",
 *     region: "eu",
 * });
 * ```
 */
class ServiceObject extends pulumi.CustomResource {
    /**
     * Get an existing ServiceObject resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ServiceObject(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ServiceObject.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ServiceObject.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["customUrl"] = state ? state.customUrl : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["opsgenieApiKey"] = state ? state.opsgenieApiKey : undefined;
            resourceInputs["region"] = state ? state.region : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            if ((!args || args.opsgenieApiKey === undefined) && !opts.urn) {
                throw new Error("Missing required property 'opsgenieApiKey'");
            }
            if ((!args || args.region === undefined) && !opts.urn) {
                throw new Error("Missing required property 'region'");
            }
            resourceInputs["customUrl"] = args ? args.customUrl : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["opsgenieApiKey"] = (args === null || args === void 0 ? void 0 : args.opsgenieApiKey) ? pulumi.secret(args.opsgenieApiKey) : undefined;
            resourceInputs["region"] = args ? args.region : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        const secretOpts = { additionalSecretOutputs: ["opsgenieApiKey"] };
        opts = pulumi.mergeOptions(opts, secretOpts);
        super(ServiceObject.__pulumiType, name, resourceInputs, opts);
    }
}
exports.ServiceObject = ServiceObject;
/** @internal */
ServiceObject.__pulumiType = 'datadog:opsgenie/serviceObject:ServiceObject';
//# sourceMappingURL=serviceObject.js.map