"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceObject = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Provides access to individual Service Objects of Datadog - PagerDuty integrations. Note that the Datadog - PagerDuty integration must be activated in the Datadog UI in order for this resource to be usable.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const testingFoo = new datadog.pagerduty.ServiceObject("testingFoo", {
 *     serviceKey: "9876543210123456789",
 *     serviceName: "testing_foo",
 * });
 * const testingBar = new datadog.pagerduty.ServiceObject("testingBar", {
 *     serviceKey: "54321098765432109876",
 *     serviceName: "testing_bar",
 * });
 * ```
 */
class ServiceObject extends pulumi.CustomResource {
    /**
     * Get an existing ServiceObject resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ServiceObject(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ServiceObject.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ServiceObject.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["serviceKey"] = state ? state.serviceKey : undefined;
            resourceInputs["serviceName"] = state ? state.serviceName : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.serviceKey === undefined) && !opts.urn) {
                throw new Error("Missing required property 'serviceKey'");
            }
            if ((!args || args.serviceName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'serviceName'");
            }
            resourceInputs["serviceKey"] = (args === null || args === void 0 ? void 0 : args.serviceKey) ? pulumi.secret(args.serviceKey) : undefined;
            resourceInputs["serviceName"] = args ? args.serviceName : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        const secretOpts = { additionalSecretOutputs: ["serviceKey"] };
        opts = pulumi.mergeOptions(opts, secretOpts);
        super(ServiceObject.__pulumiType, name, resourceInputs, opts);
    }
}
exports.ServiceObject = ServiceObject;
/** @internal */
ServiceObject.__pulumiType = 'datadog:pagerduty/serviceObject:ServiceObject';
//# sourceMappingURL=serviceObject.js.map