"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Role = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog role resource. This can be used to create and manage Datadog roles.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const bar = datadog.getPermissions({});
 * // Create a new Datadog role
 * const foo = new datadog.Role("foo", {
 *     name: "foo",
 *     permissions: [
 *         {
 *             id: bar.then(bar => bar.permissions?.monitorsDowntime),
 *         },
 *         {
 *             id: bar.then(bar => bar.permissions?.monitorsWrite),
 *         },
 *     ],
 * });
 * ```
 *
 * ## Import
 *
 * Roles can be imported using their ID, e.g.
 *
 * ```sh
 *  $ pulumi import datadog:index/role:Role example_role 000000-0000-0000-0000-000000000000
 * ```
 */
class Role extends pulumi.CustomResource {
    /**
     * Get an existing Role resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Role(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Role.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Role.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["permissions"] = state ? state.permissions : undefined;
            resourceInputs["userCount"] = state ? state.userCount : undefined;
            resourceInputs["validate"] = state ? state.validate : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["permissions"] = args ? args.permissions : undefined;
            resourceInputs["validate"] = args ? args.validate : undefined;
            resourceInputs["userCount"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(Role.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Role = Role;
/** @internal */
Role.__pulumiType = 'datadog:index/role:Role';
//# sourceMappingURL=role.js.map