"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.SecurityMonitoringDefaultRule = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog Security Monitoring Rule API resource for default rules. It can only be imported, you can't create a default rule.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const adefaultrule = new datadog.SecurityMonitoringDefaultRule("adefaultrule", {
 *     cases: [{
 *         notifications: ["@me"],
 *         status: "high",
 *     }],
 *     enabled: true,
 * });
 * ```
 *
 * ## Import
 *
 * Default rules need to be imported using their ID before applying. resource "datadog_security_monitoring_default_rule" "adefaultrule" { }
 *
 * ```sh
 *  $ pulumi import datadog:index/securityMonitoringDefaultRule:SecurityMonitoringDefaultRule adefaultrule m0o-hto-lkb
 * ```
 */
class SecurityMonitoringDefaultRule extends pulumi.CustomResource {
    /**
     * Get an existing SecurityMonitoringDefaultRule resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SecurityMonitoringDefaultRule(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SecurityMonitoringDefaultRule.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SecurityMonitoringDefaultRule.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["cases"] = state ? state.cases : undefined;
            resourceInputs["enabled"] = state ? state.enabled : undefined;
            resourceInputs["filters"] = state ? state.filters : undefined;
            resourceInputs["options"] = state ? state.options : undefined;
            resourceInputs["type"] = state ? state.type : undefined;
        }
        else {
            const args = argsOrState;
            resourceInputs["cases"] = args ? args.cases : undefined;
            resourceInputs["enabled"] = args ? args.enabled : undefined;
            resourceInputs["filters"] = args ? args.filters : undefined;
            resourceInputs["options"] = args ? args.options : undefined;
            resourceInputs["type"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(SecurityMonitoringDefaultRule.__pulumiType, name, resourceInputs, opts);
    }
}
exports.SecurityMonitoringDefaultRule = SecurityMonitoringDefaultRule;
/** @internal */
SecurityMonitoringDefaultRule.__pulumiType = 'datadog:index/securityMonitoringDefaultRule:SecurityMonitoringDefaultRule';
//# sourceMappingURL=securityMonitoringDefaultRule.js.map