"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.SecurityMonitoringFilter = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog Security Monitoring Rule API resource for security filters.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const myFilter = new datadog.SecurityMonitoringFilter("myFilter", {
 *     exclusionFilters: [
 *         {
 *             name: "first",
 *             query: "exclude some logs",
 *         },
 *         {
 *             name: "second",
 *             query: "exclude some other logs",
 *         },
 *     ],
 *     isEnabled: true,
 *     name: "My filter",
 *     query: "The filter is filtering.",
 * });
 * ```
 *
 * ## Import
 *
 * Security monitoring filters can be imported using ID, e.g.
 *
 * ```sh
 *  $ pulumi import datadog:index/securityMonitoringFilter:SecurityMonitoringFilter my_filter m0o-hto-lkb
 * ```
 */
class SecurityMonitoringFilter extends pulumi.CustomResource {
    /**
     * Get an existing SecurityMonitoringFilter resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SecurityMonitoringFilter(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SecurityMonitoringFilter.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SecurityMonitoringFilter.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["exclusionFilters"] = state ? state.exclusionFilters : undefined;
            resourceInputs["filteredDataType"] = state ? state.filteredDataType : undefined;
            resourceInputs["isEnabled"] = state ? state.isEnabled : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["query"] = state ? state.query : undefined;
            resourceInputs["version"] = state ? state.version : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.isEnabled === undefined) && !opts.urn) {
                throw new Error("Missing required property 'isEnabled'");
            }
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            if ((!args || args.query === undefined) && !opts.urn) {
                throw new Error("Missing required property 'query'");
            }
            resourceInputs["exclusionFilters"] = args ? args.exclusionFilters : undefined;
            resourceInputs["filteredDataType"] = args ? args.filteredDataType : undefined;
            resourceInputs["isEnabled"] = args ? args.isEnabled : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["query"] = args ? args.query : undefined;
            resourceInputs["version"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(SecurityMonitoringFilter.__pulumiType, name, resourceInputs, opts);
    }
}
exports.SecurityMonitoringFilter = SecurityMonitoringFilter;
/** @internal */
SecurityMonitoringFilter.__pulumiType = 'datadog:index/securityMonitoringFilter:SecurityMonitoringFilter';
//# sourceMappingURL=securityMonitoringFilter.js.map