"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.SensitiveDataScannerRule = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog SensitiveDataScannerRule resource. This can be used to create and manage Datadog sensitive_data_scanner_rule.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Create new sensitive_data_scanner_rule resource in a sensitive_data_scanner_group
 * const mygroup = new datadog.SensitiveDataScannerGroup("mygroup", {
 *     name: "My new scanning group",
 *     description: "A relevant description",
 *     filter: {
 *         query: "service:my-service",
 *     },
 *     isEnabled: true,
 *     productLists: ["apm"],
 * });
 * const myrule = new datadog.SensitiveDataScannerRule("myrule", {
 *     name: "My new rule",
 *     description: "Another description",
 *     groupId: mygroup.id,
 *     excludedNamespaces: ["username"],
 *     isEnabled: true,
 *     pattern: "myregex",
 *     tags: ["sensitive_data:true"],
 *     textReplacement: {
 *         numberOfChars: 0,
 *         replacementString: "",
 *         type: "hash",
 *     },
 * });
 * const awsSp = datadog.getSensitiveDataScannerStandardPattern({
 *     filter: "AWS Access Key ID Scanner",
 * });
 * const mylibraryrule = new datadog.SensitiveDataScannerRule("mylibraryrule", {
 *     name: "My library rule",
 *     description: "A description",
 *     groupId: mygroup.id,
 *     standardPatternId: awsSp.then(awsSp => awsSp.id),
 *     excludedNamespaces: ["username"],
 *     isEnabled: true,
 *     tags: ["sensitive_data:true"],
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/sensitiveDataScannerRule:SensitiveDataScannerRule new_list ""
 * ```
 */
class SensitiveDataScannerRule extends pulumi.CustomResource {
    /**
     * Get an existing SensitiveDataScannerRule resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SensitiveDataScannerRule(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SensitiveDataScannerRule.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SensitiveDataScannerRule.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["description"] = state ? state.description : undefined;
            resourceInputs["excludedNamespaces"] = state ? state.excludedNamespaces : undefined;
            resourceInputs["groupId"] = state ? state.groupId : undefined;
            resourceInputs["isEnabled"] = state ? state.isEnabled : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["namespaces"] = state ? state.namespaces : undefined;
            resourceInputs["pattern"] = state ? state.pattern : undefined;
            resourceInputs["standardPatternId"] = state ? state.standardPatternId : undefined;
            resourceInputs["tags"] = state ? state.tags : undefined;
            resourceInputs["textReplacement"] = state ? state.textReplacement : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.groupId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'groupId'");
            }
            resourceInputs["description"] = args ? args.description : undefined;
            resourceInputs["excludedNamespaces"] = args ? args.excludedNamespaces : undefined;
            resourceInputs["groupId"] = args ? args.groupId : undefined;
            resourceInputs["isEnabled"] = args ? args.isEnabled : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["namespaces"] = args ? args.namespaces : undefined;
            resourceInputs["pattern"] = args ? args.pattern : undefined;
            resourceInputs["standardPatternId"] = args ? args.standardPatternId : undefined;
            resourceInputs["tags"] = args ? args.tags : undefined;
            resourceInputs["textReplacement"] = args ? args.textReplacement : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(SensitiveDataScannerRule.__pulumiType, name, resourceInputs, opts);
    }
}
exports.SensitiveDataScannerRule = SensitiveDataScannerRule;
/** @internal */
SensitiveDataScannerRule.__pulumiType = 'datadog:index/sensitiveDataScannerRule:SensitiveDataScannerRule';
//# sourceMappingURL=sensitiveDataScannerRule.js.map