"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceDefinitionYaml = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog service definition resource. This can be used to create and manage Datadog service definitions in the service catalog using the YAML/JSON definition.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const serviceDefinition = new datadog.ServiceDefinitionYaml("serviceDefinition", {serviceDefinition: `schema-version: v2
 * dd-service: shopping-cart
 * team: E Commerce
 * contacts:
 *   - name: Support Email
 *     type: email
 *     contact: team@shopping.com
 *   - name: Support Slack
 *     type: slack
 *     contact: https://www.slack.com/archives/shopping-cart
 * repos:
 *   - name: shopping-cart source code
 *     provider: github
 *     url: http://github/shopping-cart
 * docs:
 *   - name: shopping-cart architecture
 *     provider: gdoc
 *     url: https://google.drive/shopping-cart-architecture
 *   - name: shopping-cart service Wiki
 *     provider: wiki
 *     url: https://wiki/shopping-cart
 * links:
 *   - name: shopping-cart runbook
 *     type: runbook
 *     url: https://runbook/shopping-cart
 * tags:
 *   - business-unit:retail
 *   - cost-center:engineering
 * integrations:
 *   pagerduty: https://www.pagerduty.com/service-directory/Pshopping-cart
 * extensions:
 *   datadoghq.com/shopping-cart:
 *     customField: customValue
 *
 * `});
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/serviceDefinitionYaml:ServiceDefinitionYaml service_definition "<dd-service>"
 * ```
 */
class ServiceDefinitionYaml extends pulumi.CustomResource {
    /**
     * Get an existing ServiceDefinitionYaml resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new ServiceDefinitionYaml(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of ServiceDefinitionYaml.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === ServiceDefinitionYaml.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["serviceDefinition"] = state ? state.serviceDefinition : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.serviceDefinition === undefined) && !opts.urn) {
                throw new Error("Missing required property 'serviceDefinition'");
            }
            resourceInputs["serviceDefinition"] = args ? args.serviceDefinition : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(ServiceDefinitionYaml.__pulumiType, name, resourceInputs, opts);
    }
}
exports.ServiceDefinitionYaml = ServiceDefinitionYaml;
/** @internal */
ServiceDefinitionYaml.__pulumiType = 'datadog:index/serviceDefinitionYaml:ServiceDefinitionYaml';
//# sourceMappingURL=serviceDefinitionYaml.js.map