"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Channel = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("../utilities");
/**
 * Resource for interacting with the Datadog Slack channel API
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const testChannel = new datadog.slack.Channel("testChannel", {
 *     accountName: "foo",
 *     channelName: "#test_channel",
 *     display: {
 *         message: true,
 *         notified: false,
 *         snapshot: false,
 *         tags: true,
 *     },
 * });
 * ```
 *
 * ## Import
 *
 * Slack channel integrations can be imported using their account_name and channel_name separated with a colon (`:`).
 *
 * ```sh
 *  $ pulumi import datadog:slack/channel:Channel test_channel "foo:#test_channel"
 * ```
 */
class Channel extends pulumi.CustomResource {
    /**
     * Get an existing Channel resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Channel(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Channel.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Channel.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["accountName"] = state ? state.accountName : undefined;
            resourceInputs["channelName"] = state ? state.channelName : undefined;
            resourceInputs["display"] = state ? state.display : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.accountName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'accountName'");
            }
            if ((!args || args.channelName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'channelName'");
            }
            if ((!args || args.display === undefined) && !opts.urn) {
                throw new Error("Missing required property 'display'");
            }
            resourceInputs["accountName"] = args ? args.accountName : undefined;
            resourceInputs["channelName"] = args ? args.channelName : undefined;
            resourceInputs["display"] = args ? args.display : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(Channel.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Channel = Channel;
/** @internal */
Channel.__pulumiType = 'datadog:slack/channel:Channel';
//# sourceMappingURL=channel.js.map