"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.SloCorrection = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Resource for interacting with the sloCorrection API.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Create a new Datadog SLO correction. slo_id can be derived from slo resource or specify an slo id of an existing SLO.
 * const exampleSlo = new datadog.ServiceLevelObjective("exampleSlo", {
 *     name: "example slo",
 *     type: "metric",
 *     description: "some updated description about example_slo SLO",
 *     query: {
 *         numerator: "sum:my.metric{type:good}.as_count()",
 *         denominator: "sum:my.metric{type:good}.as_count() + sum:my.metric{type:bad}.as_count()",
 *     },
 *     thresholds: [{
 *         timeframe: "7d",
 *         target: 99.5,
 *         warning: 99.8,
 *     }],
 *     tags: ["foo:bar"],
 * });
 * const exampleSloCorrection = new datadog.SloCorrection("exampleSloCorrection", {
 *     category: "Scheduled Maintenance",
 *     description: "correction example",
 *     start: 1735707000,
 *     end: 1735718600,
 *     sloId: exampleSlo.id,
 *     timezone: "UTC",
 * });
 * const exampleSloCorrectionWithRecurrence = new datadog.SloCorrection("exampleSloCorrectionWithRecurrence", {
 *     category: "Scheduled Maintenance",
 *     description: "correction example with recurrence",
 *     start: 1735707000,
 *     rrule: "FREQ=DAILY;INTERVAL=3;COUNT=3",
 *     duration: 3600,
 *     sloId: exampleSlo.id,
 *     timezone: "UTC",
 * });
 * ```
 *
 * ## Import
 *
 * ```sh
 *  $ pulumi import datadog:index/sloCorrection:SloCorrection testing_slo_correction 11111111-3fee-11eb-8a13-77cd9f15119e
 * ```
 */
class SloCorrection extends pulumi.CustomResource {
    /**
     * Get an existing SloCorrection resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SloCorrection(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SloCorrection.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SloCorrection.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["category"] = state ? state.category : undefined;
            resourceInputs["description"] = state ? state.description : undefined;
            resourceInputs["duration"] = state ? state.duration : undefined;
            resourceInputs["end"] = state ? state.end : undefined;
            resourceInputs["rrule"] = state ? state.rrule : undefined;
            resourceInputs["sloId"] = state ? state.sloId : undefined;
            resourceInputs["start"] = state ? state.start : undefined;
            resourceInputs["timezone"] = state ? state.timezone : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.category === undefined) && !opts.urn) {
                throw new Error("Missing required property 'category'");
            }
            if ((!args || args.sloId === undefined) && !opts.urn) {
                throw new Error("Missing required property 'sloId'");
            }
            if ((!args || args.start === undefined) && !opts.urn) {
                throw new Error("Missing required property 'start'");
            }
            resourceInputs["category"] = args ? args.category : undefined;
            resourceInputs["description"] = args ? args.description : undefined;
            resourceInputs["duration"] = args ? args.duration : undefined;
            resourceInputs["end"] = args ? args.end : undefined;
            resourceInputs["rrule"] = args ? args.rrule : undefined;
            resourceInputs["sloId"] = args ? args.sloId : undefined;
            resourceInputs["start"] = args ? args.start : undefined;
            resourceInputs["timezone"] = args ? args.timezone : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(SloCorrection.__pulumiType, name, resourceInputs, opts);
    }
}
exports.SloCorrection = SloCorrection;
/** @internal */
SloCorrection.__pulumiType = 'datadog:index/sloCorrection:SloCorrection';
//# sourceMappingURL=sloCorrection.js.map