"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyntheticsGlobalVariable = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog synthetics global variable resource. This can be used to create and manage Datadog synthetics global variables.
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * const testVariable = new datadog.SyntheticsGlobalVariable("testVariable", {
 *     description: "Description of the variable",
 *     name: "EXAMPLE_VARIABLE",
 *     tags: [
 *         "foo:bar",
 *         "env:test",
 *     ],
 *     value: "variable-value",
 * });
 * ```
 *
 * ## Import
 *
 * Synthetics global variables can be imported using their string ID, e.g.
 *
 * ```sh
 *  $ pulumi import datadog:index/syntheticsGlobalVariable:SyntheticsGlobalVariable fizz abcde123-fghi-456-jkl-mnopqrstuv
 * ```
 */
class SyntheticsGlobalVariable extends pulumi.CustomResource {
    /**
     * Get an existing SyntheticsGlobalVariable resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SyntheticsGlobalVariable(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SyntheticsGlobalVariable.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SyntheticsGlobalVariable.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["description"] = state ? state.description : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["options"] = state ? state.options : undefined;
            resourceInputs["parseTestId"] = state ? state.parseTestId : undefined;
            resourceInputs["parseTestOptions"] = state ? state.parseTestOptions : undefined;
            resourceInputs["restrictedRoles"] = state ? state.restrictedRoles : undefined;
            resourceInputs["secure"] = state ? state.secure : undefined;
            resourceInputs["tags"] = state ? state.tags : undefined;
            resourceInputs["value"] = state ? state.value : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            if ((!args || args.value === undefined) && !opts.urn) {
                throw new Error("Missing required property 'value'");
            }
            resourceInputs["description"] = args ? args.description : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["options"] = args ? args.options : undefined;
            resourceInputs["parseTestId"] = args ? args.parseTestId : undefined;
            resourceInputs["parseTestOptions"] = args ? args.parseTestOptions : undefined;
            resourceInputs["restrictedRoles"] = args ? args.restrictedRoles : undefined;
            resourceInputs["secure"] = args ? args.secure : undefined;
            resourceInputs["tags"] = args ? args.tags : undefined;
            resourceInputs["value"] = (args === null || args === void 0 ? void 0 : args.value) ? pulumi.secret(args.value) : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        const secretOpts = { additionalSecretOutputs: ["value"] };
        opts = pulumi.mergeOptions(opts, secretOpts);
        super(SyntheticsGlobalVariable.__pulumiType, name, resourceInputs, opts);
    }
}
exports.SyntheticsGlobalVariable = SyntheticsGlobalVariable;
/** @internal */
SyntheticsGlobalVariable.__pulumiType = 'datadog:index/syntheticsGlobalVariable:SyntheticsGlobalVariable';
//# sourceMappingURL=syntheticsGlobalVariable.js.map