"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyntheticsTest = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * Provides a Datadog synthetics test resource. This can be used to create and manage Datadog synthetics test.
 *
 * #### *Warning*
 * Starting from version 3.1.0+, the direct usage of global variables in the configuration is deprecated, in favor of
 * local variables of type `global`. As an example, if you were previously using `{{ GLOBAL_VAR }}` directly in your
 * configuration, add a `configVariable` of type `global` with the `id` matching the `id` of the global variable `GLOBAL_VAR`, which can be found in the Synthetics UI or from the output of the `datadog.SyntheticsGlobalVariable` resource. The name can be chosen freely.
 *
 * In practice, it means going from (simplified configuration):
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * ```
 *
 * to
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * ```
 *
 * which you can now use in your request definition:
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * ```
 *
 * ## Example Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as datadog from "@pulumi/datadog";
 *
 * // Example Usage (Synthetics API test)
 * // Create a new Datadog Synthetics API/HTTP test on https://www.example.org
 * const testApi = new datadog.SyntheticsTest("testApi", {
 *     assertions: [{
 *         operator: "is",
 *         target: "200",
 *         type: "statusCode",
 *     }],
 *     locations: ["aws:eu-central-1"],
 *     message: "Notify @pagerduty",
 *     name: "An API test on example.org",
 *     optionsList: {
 *         monitorOptions: {
 *             renotifyInterval: 120,
 *         },
 *         retry: {
 *             count: 2,
 *             interval: 300,
 *         },
 *         tickEvery: 900,
 *     },
 *     requestDefinition: {
 *         method: "GET",
 *         url: "https://www.example.org",
 *     },
 *     requestHeaders: {
 *         Authentication: "Token: 1234566789",
 *         "Content-Type": "application/json",
 *     },
 *     status: "live",
 *     subtype: "http",
 *     tags: [
 *         "foo:bar",
 *         "foo",
 *         "env:test",
 *     ],
 *     type: "api",
 * });
 * // Example Usage (Synthetics SSL test)
 * // Create a new Datadog Synthetics API/SSL test on example.org
 * const testSsl = new datadog.SyntheticsTest("testSsl", {
 *     assertions: [{
 *         operator: "isInMoreThan",
 *         target: "30",
 *         type: "certificate",
 *     }],
 *     locations: ["aws:eu-central-1"],
 *     message: "Notify @pagerduty",
 *     name: "An API test on example.org",
 *     optionsList: {
 *         acceptSelfSigned: true,
 *         tickEvery: 900,
 *     },
 *     requestDefinition: {
 *         host: "example.org",
 *         port: 443,
 *     },
 *     status: "live",
 *     subtype: "ssl",
 *     tags: [
 *         "foo:bar",
 *         "foo",
 *         "env:test",
 *     ],
 *     type: "api",
 * });
 * // Example Usage (Synthetics TCP test)
 * // Create a new Datadog Synthetics API/TCP test on example.org
 * const testTcp = new datadog.SyntheticsTest("testTcp", {
 *     assertions: [{
 *         operator: "lessThan",
 *         target: "2000",
 *         type: "responseTime",
 *     }],
 *     configVariables: [{
 *         id: "76636cd1-82e2-4aeb-9cfe-51366a8198a2",
 *         name: "MY_GLOBAL_VAR",
 *         type: "global",
 *     }],
 *     locations: ["aws:eu-central-1"],
 *     message: "Notify @pagerduty",
 *     name: "An API test on example.org",
 *     optionsList: {
 *         tickEvery: 900,
 *     },
 *     requestDefinition: {
 *         host: "example.org",
 *         port: 443,
 *     },
 *     status: "live",
 *     subtype: "tcp",
 *     tags: [
 *         "foo:bar",
 *         "foo",
 *         "env:test",
 *     ],
 *     type: "api",
 * });
 * // Example Usage (Synthetics DNS test)
 * // Create a new Datadog Synthetics API/DNS test on example.org
 * const testDns = new datadog.SyntheticsTest("testDns", {
 *     assertions: [{
 *         operator: "is",
 *         property: "A",
 *         target: "0.0.0.0",
 *         type: "recordSome",
 *     }],
 *     locations: ["aws:eu-central-1"],
 *     message: "Notify @pagerduty",
 *     name: "An API test on example.org",
 *     optionsList: {
 *         tickEvery: 900,
 *     },
 *     requestDefinition: {
 *         host: "example.org",
 *     },
 *     status: "live",
 *     subtype: "dns",
 *     tags: [
 *         "foo:bar",
 *         "foo",
 *         "env:test",
 *     ],
 *     type: "api",
 * });
 * // Example Usage (Synthetics Multistep API test)
 * // Create a new Datadog Synthetics Multistep API test
 * const test = new datadog.SyntheticsTest("test", {
 *     apiSteps: [
 *         {
 *             assertions: [{
 *                 operator: "is",
 *                 target: "200",
 *                 type: "statusCode",
 *             }],
 *             name: "An API test on example.org",
 *             requestDefinition: {
 *                 method: "GET",
 *                 url: "https://example.org",
 *             },
 *             requestHeaders: {
 *                 Authentication: "Token: 1234566789",
 *                 "Content-Type": "application/json",
 *             },
 *             subtype: "http",
 *         },
 *         {
 *             assertions: [{
 *                 operator: "is",
 *                 target: "200",
 *                 type: "statusCode",
 *             }],
 *             name: "An API test on example.org",
 *             requestDefinition: {
 *                 method: "GET",
 *                 url: "http://example.org",
 *             },
 *             subtype: "http",
 *         },
 *     ],
 *     locations: ["aws:eu-central-1"],
 *     name: "Multistep API test",
 *     optionsList: {
 *         acceptSelfSigned: true,
 *         tickEvery: 900,
 *     },
 *     status: "live",
 *     subtype: "multi",
 *     type: "api",
 * });
 * // Example Usage (Synthetics Browser test)
 * // Create a new Datadog Synthetics Browser test starting on https://www.example.org
 * const testBrowser = new datadog.SyntheticsTest("testBrowser", {
 *     browserSteps: [{
 *         name: "Check current url",
 *         params: {
 *             check: "contains",
 *             value: "datadoghq",
 *         },
 *         type: "assertCurrentUrl",
 *     }],
 *     browserVariables: [
 *         {
 *             example: "597",
 *             name: "MY_PATTERN_VAR",
 *             pattern: "{{numeric(3)}}",
 *             type: "text",
 *         },
 *         {
 *             example: "jd8-afe-ydv.4546132139@synthetics.dtdg.co",
 *             name: "MY_EMAIL_VAR",
 *             pattern: "jd8-afe-ydv.{{ numeric(10) }}@synthetics.dtdg.co",
 *             type: "email",
 *         },
 *         {
 *             id: "76636cd1-82e2-4aeb-9cfe-51366a8198a2",
 *             name: "MY_GLOBAL_VAR",
 *             type: "global",
 *         },
 *     ],
 *     deviceIds: ["laptop_large"],
 *     locations: ["aws:eu-central-1"],
 *     message: "Notify @qa",
 *     name: "A Browser test on example.org",
 *     optionsList: {
 *         tickEvery: 3600,
 *     },
 *     requestDefinition: {
 *         method: "GET",
 *         url: "https://app.datadoghq.com",
 *     },
 *     status: "paused",
 *     tags: [],
 *     type: "browser",
 * });
 * ```
 *
 * ## Import
 *
 * Synthetics tests can be imported using their public string ID, e.g.
 *
 * ```sh
 *  $ pulumi import datadog:index/syntheticsTest:SyntheticsTest fizz abc-123-xyz
 * ```
 */
class SyntheticsTest extends pulumi.CustomResource {
    /**
     * Get an existing SyntheticsTest resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new SyntheticsTest(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of SyntheticsTest.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === SyntheticsTest.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["apiSteps"] = state ? state.apiSteps : undefined;
            resourceInputs["assertions"] = state ? state.assertions : undefined;
            resourceInputs["browserSteps"] = state ? state.browserSteps : undefined;
            resourceInputs["browserVariables"] = state ? state.browserVariables : undefined;
            resourceInputs["configVariables"] = state ? state.configVariables : undefined;
            resourceInputs["deviceIds"] = state ? state.deviceIds : undefined;
            resourceInputs["locations"] = state ? state.locations : undefined;
            resourceInputs["message"] = state ? state.message : undefined;
            resourceInputs["monitorId"] = state ? state.monitorId : undefined;
            resourceInputs["name"] = state ? state.name : undefined;
            resourceInputs["optionsList"] = state ? state.optionsList : undefined;
            resourceInputs["requestBasicauth"] = state ? state.requestBasicauth : undefined;
            resourceInputs["requestClientCertificate"] = state ? state.requestClientCertificate : undefined;
            resourceInputs["requestDefinition"] = state ? state.requestDefinition : undefined;
            resourceInputs["requestHeaders"] = state ? state.requestHeaders : undefined;
            resourceInputs["requestProxy"] = state ? state.requestProxy : undefined;
            resourceInputs["requestQuery"] = state ? state.requestQuery : undefined;
            resourceInputs["setCookie"] = state ? state.setCookie : undefined;
            resourceInputs["status"] = state ? state.status : undefined;
            resourceInputs["subtype"] = state ? state.subtype : undefined;
            resourceInputs["tags"] = state ? state.tags : undefined;
            resourceInputs["type"] = state ? state.type : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.locations === undefined) && !opts.urn) {
                throw new Error("Missing required property 'locations'");
            }
            if ((!args || args.name === undefined) && !opts.urn) {
                throw new Error("Missing required property 'name'");
            }
            if ((!args || args.status === undefined) && !opts.urn) {
                throw new Error("Missing required property 'status'");
            }
            if ((!args || args.type === undefined) && !opts.urn) {
                throw new Error("Missing required property 'type'");
            }
            resourceInputs["apiSteps"] = args ? args.apiSteps : undefined;
            resourceInputs["assertions"] = args ? args.assertions : undefined;
            resourceInputs["browserSteps"] = args ? args.browserSteps : undefined;
            resourceInputs["browserVariables"] = args ? args.browserVariables : undefined;
            resourceInputs["configVariables"] = args ? args.configVariables : undefined;
            resourceInputs["deviceIds"] = args ? args.deviceIds : undefined;
            resourceInputs["locations"] = args ? args.locations : undefined;
            resourceInputs["message"] = args ? args.message : undefined;
            resourceInputs["name"] = args ? args.name : undefined;
            resourceInputs["optionsList"] = args ? args.optionsList : undefined;
            resourceInputs["requestBasicauth"] = args ? args.requestBasicauth : undefined;
            resourceInputs["requestClientCertificate"] = args ? args.requestClientCertificate : undefined;
            resourceInputs["requestDefinition"] = args ? args.requestDefinition : undefined;
            resourceInputs["requestHeaders"] = args ? args.requestHeaders : undefined;
            resourceInputs["requestProxy"] = args ? args.requestProxy : undefined;
            resourceInputs["requestQuery"] = args ? args.requestQuery : undefined;
            resourceInputs["setCookie"] = args ? args.setCookie : undefined;
            resourceInputs["status"] = args ? args.status : undefined;
            resourceInputs["subtype"] = args ? args.subtype : undefined;
            resourceInputs["tags"] = args ? args.tags : undefined;
            resourceInputs["type"] = args ? args.type : undefined;
            resourceInputs["monitorId"] = undefined /*out*/;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(SyntheticsTest.__pulumiType, name, resourceInputs, opts);
    }
}
exports.SyntheticsTest = SyntheticsTest;
/** @internal */
SyntheticsTest.__pulumiType = 'datadog:index/syntheticsTest:SyntheticsTest';
//# sourceMappingURL=syntheticsTest.js.map